<template>
  <spotPageWrapper>
    <template slot="header">
      <router-link
          class="icon chevron-left"
          :to="{ path: routeBackUrl }"
      />
      <h1 class="title">Заказ на проведение аукциона {{ spotNumber }}</h1>
      <span class="ref">{{ auctionStatusText }}</span>
    </template>
    <template slot="left">
      <ob-loader v-if="isLoading" />
      <template v-if="isReadySpot">
        <div
          v-if="auctionStatus === 'CANCELLED'"
          class="ob-spot-canceled-block"
        >
          Отменено
        </div>
        <h2>Поиск исполнителя на маршрут {{ fromLocationTitleRu }} → {{ toLocationTitleRu }}</h2>
        <div class="ob-spot-path">
          <cardPath
              role="client"
              :locationFrom="fromLocationTitleRu"
              :locationTo="toLocationTitleRu"
              :route="routeLengthInKm"
              :points="routePoints"
          />
        </div>

        <div class="ob-spot-description" v-if="isSummarizing && !isAuctionCancelled">
          <div class="ob-spot-description__type">
            <i class="icon tractor-semi-trailer-izoterm-b -cobalt" />{{ resourceTypeTitle }}
          </div>

          <div class="ob-spot-row">
            <div class="ob-spot-col">
              <ob-select
                  v-if="!isOrderProcessed"
                  label="Назначенный исполнитель"
                  placeholder="Выберите из списка"
                  valueExp="bidUuid"
                  display-exp="participantTitle"
                  :isSearch="true"
                  :value="participant"
                  :items="participants"
                  @input="onSelectWinner"
                  ref="winner">

                <template v-slot="{ items }">
                  <div v-if="items" class="winner-list">
                    <div class="winner-list__items">
                      <div v-for="(item, index) in items"
                           :key="item.participantTitle"
                           class="winner-list__item"
                           @click="selectWinner(item)"
                      >
                        <div><span>{{ index + 1 }}</span></div>
                        <div>{{ item.participantTitle }}</div>
                        <div><span>ИНН</span> {{ item.inn }}</div>
                        <div>{{ item.bid / 100 | currency }}₽ <span>без НДС</span></div>
                      </div>
                    </div>
                  </div>
                </template>
              </ob-select>
              <div class="winning-bet" v-if="isOrderProcessed">
                <div class="winning-bet__label">Назначенный исполнитель</div>
                <div class="winning-bet__price">{{ winningParticipant }}</div>
              </div>
            </div>
            <div class="ob-spot-col ob-spot-bet">
              <div class="winning-bet">
                <div class="winning-bet__label">Победившая ставка, без НДС.
                  <template v-if="Number.parseInt(winningVat)">НДС {{ winningVat }}&nbsp;₽</template>
                </div>
                <div class="winning-bet__price">{{ winningBet }}&nbsp;₽</div>
              </div>
            </div>
          </div>

          <spotPropertiesBlueBox
              :cargoTypes="cargoTypes"
              :temperatureModeTitle="temperatureModeTitle"
              :dangerousClassTitle="dangerousClassTitle"
              :needTracking="needTracking"
          />

          <ob-button
              v-if="!isOrderProcessed"
              label="Назначить победителя"
              @click="setWinner"
              class="btn-winner"
              :disabled="isHideWinnerBtn"
          />
        </div>

        <div class="ob-spot-description" v-if="!isSummarizing || isAuctionCancelled">
          <div class="ob-spot-description__type">
            <i class="icon tractor-semi-trailer-izoterm-b -cobalt" />{{ resourceTypeTitle }}
          </div>

          <spotPropertiesBlueBox
              :cargoTypes="cargoTypes"
              :temperatureModeTitle="temperatureModeTitle"
              :dangerousClassTitle="dangerousClassTitle"
              :needTracking="needTracking"
          />

          <spotInfoCard
              v-if="isAuctionCancelled || isAuctionInProcess || isAuctionNew"
              :cargoWaybillPrice="cargoWaybillPrice"
              :requirements="requirements"
              :comment="comment"
              :files="files"
              :contactPerson="contactPerson"
              :externalNumber="externalNumber"
          />
        </div>

        <h2 v-if="hasSpotEvents">События</h2>

        <div class="ob-spot-event" v-for="(event, index) in spotEvents" :key="index">
          <div class="ob-spot-event__item">
            <p>
              {{ transformTime(event.eventDt) }} <br />
              {{ transformDate(event.eventDt) }}
            </p>
            <p>{{ event.eventTitle }}</p>
            <p>{{ event.creatorTitle ? event.creatorTitle : event.creatorType === 'TRACKING' ? 'Трекинг' : 'Системное' }}</p>
          </div>
        </div>
      </template>
      <template v-else-if="!isReadySpot && !isLoading">
        <p>Попробуйте обновить страницу через 5мин</p>
      </template>

      <ob-modal
          ref="cancelSpotModalItem"
          :is-show-controls="true"
          :is-error="true"
          title="Отмена спота"
          size="small"
          okText="Отменить"
          cancelText="Не отменять"
          @submit="onCancelSpot"
      >
        <p>Вы уверены, что хотите отменить спот-аукцион?</p>
      </ob-modal>
    </template>
    <template slot="right">
      <ObTabs>
        <ObTabsPane title="Аукцион" :is-selected="true">
          <div class="form-content">
            <template v-if="isReadyAuction">
              <div class="ob-spot-auction">
                <div class="ob-spot-auction__status">
                  <span :class="classColor">{{ auctionStatusText }}</span>
                  <ObMenuDropdown
                    v-if="!isAuctionCancelled && !isAuctionProcessed"
                    :items="dropdownMenu"
                  />
                </div>
                <div class="ob-spot-auction__icons">
                  <i class="icon blind-auction" />
                  <span>{{ viewsCount }}</span>
                  <i class="icon auction" />
                  <span>{{ bidsCount }}</span>
                  <i class="icon clock" />
                  <ob-countdown :duration="actualTime" />
                </div>
                <div class="ob-spot-auction__rate" :class="classColor">
                  {{ bestBidText }}
                </div>
                <div>
                  <div class="ob-spot-auction__price" :class="classColor">
                    {{ currentPriceValue }}&nbsp;₽<i class="icon question" />
                  </div>
                  <div class="ob-spot-auction__nds">
                    {{ vatAmountValue }}
                  </div>
                </div>
              </div>
              <div class="ob-spot-rate">
                <div class="ob-spot-rate__wrap">
                  <template v-if="bids.length">
                    <ObTable
                      :items="bids"
                      :columns="auctionColumns"
                      :functional-panel="false"
                      :footer-disabled="true"
                    />
                  </template>
                  <div v-else class="ob-spot-rate__empty">
                    Здесь пока нет ни&nbsp;одной ставки
                  </div>
                </div>
              </div>
            </template>
            <ob-loader v-if="!isReadyAuction" />
          </div>
        </ObTabsPane>
        <ObTabsPane title="Участники">
          <obFuncPanel
            @search="onSearch"
            :columns="columnsParticipants"
            :show-column-filter="false"
            :show-filter="false"
            :show-group="false"
            :show-sort="false"
        />
        <ObTable
            v-if="participantsItems.length"
            class="participants-table"
            :columns="columnsParticipants"
            :items="participantsItemsSearch"
            :checked-rows="participantsUuid"
            :group-title-html="tableGroupTitleHtml"
            :table-layout-fixed="false"
            :is-header="false"
            :functional-panel="false"
            :with-checkboxes="false"
            :footer-disabled="true"
            group-by="group"
            @row-toggle="onToggle"
            @group-toggle="onToggle"
        >
          <template #participant="{data}">
            <participantSlot :item="data.item" />
          </template>
        </ObTable>
       </ObTabsPane>
      </ObTabs>
    </template>
  </spotPageWrapper>
</template>

<script>
import api from '@/api'
import cardPath from '../components/path'
import ObCountdown from 'common-components/src/obComponents/obCountdown/index'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import ObTabs from 'common-components/src/obComponents/obTabs'
import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane'
import ObFuncPanel from 'common-components/src/obComponents/obFuncPanel'
import spotPageWrapper from '@/pages/spotPage/spotPageWrapper'
import spotPropertiesBlueBox from '@/pages/spotPage/spotItem/spotPropertiesBlueBox'
import spotInfoCard from '@/pages/spotPage/spotItem/spotInfoCard'
import { AUCTION_STATUS, ORDER_STATUS } from '@/resources/enum'
import { formatNumber } from 'common-components/src/helpers/common'
import moment from 'moment'
import ObTable from 'common-components/src/obComponents/obTable'
import ObSelect from 'common-components/src/obComponents/obSelect/index'
import ObButton from 'common-components/src/obComponents/obButton/index'
import ObLoader from 'common-components/src/obComponents/obLoader'
import ObModal from 'common-components/src/obComponents/obModal/index'
import participantSlot from '@/pages/spotPage/slots/participant'

export default {
  name: 'spotItem',
  components: {
    ObModal,
    cardPath,
    ObSelect,
    ObButton,
    ObLoader,
    ObCountdown,
    ObMenuDropdown,
    ObTable,
    ObTabs,
    ObTabsPane,
    ObFuncPanel,
    spotPageWrapper,
    spotPropertiesBlueBox,
    spotInfoCard,
    participantSlot
  },
  data() {
    return {
      dropdownMenu: [
        { title: 'Отменить спот', method: this.onOpenModal }
      ],
      isLoading: true,
      isReadySpot: false,
      isReadyAuction: false,
      auctionTimer: '',
      participant: '',
      participants: [],
      spotNumber: '',
      auctionUuid: '',
      orderStatus: null,
      auctionStatus: null,
      auctionStatusText: '',
      resourceTypeTitle: '',
      cargoTypes: '',
      temperatureModeTitle: '',
      dangerousClassTitle: '',
      needTracking: false,
      cargoWaybillPrice: null,
      requirements: '',
      comment: '',
      externalNumber: '',
      files: [],
      contactPerson: '',
      fromLocationTitleRu: '',
      toLocationTitleRu: '',
      routeLengthInKm: null,
      routePoints: [],

      actualTime: null,
      viewsCount: null,
      bidsCount: null,
      currentPrice: null,
      vatAmount: null,
      bids: [],

      winningBet: null,
      winningVat: null,
      winningParticipant: '',

      spotEvents: [],
      spotEventsTimer: null,

      participantsItems: [],
      columnsParticipants: [{
        key: 'participant',
        width: '200',
        slotName: 'participant'
      }],
      search: '',
      participantsUuid: [],
    }
  },
  mounted () {
    api.spotAuction.getActualSpotItem(this.$route.params.uuid)
       .then((response) => {
         const formData = response.data

         this.spotNumber = formData.number
         this.auctionUuid = formData.auctionUuid
         this.orderStatus = formData.orderStatus
         this.resourceTypeTitle = formData.resourceTypeTitle
         this.cargoTypes = formData.cargoTypes.map(item => item.cargoTypeTitle).join(' / ')
         this.temperatureModeTitle = formData.temperatureModeTitle
         this.dangerousClassTitle = formData.dangerousClassTitle
         this.needTracking = formData.needTracking
         this.cargoWaybillPrice = formData.cargoWaybillPrice
         this.requirements = formData.requirements.length ? formData.requirements.map(item => item.requirementTitle).join(' / ') : '–'
         this.comment = formData.comment ? formData.comment : '–'
         this.files = formData.files ? formData.files : []
         this.contactPerson = formData.contactPerson ? this.preprocContactPerson(formData.contactPerson) : '–'
         this.fromLocationTitleRu = formData.fromLocationTitleRu
         this.toLocationTitleRu = formData.toLocationTitleRu
         this.pointsRu = formData.toLocationTitleRu
         this.routeLengthInKm = formData.routeLengthInKm
         this.routePoints = formData.routePoints
         this.externalNumber = formData.externalNumber ? formData.externalNumber : '–'

         this.getActualAuction(formData.auctionUuid, this.$route.params.uuid)

         this.isLoading = false
         this.isReadySpot = true

         if (this.isSummarizing) {
           this.getParticipantList(formData)

           clearTimeout(this.auctionTimer)
         }
         if (this.isOrderProcessed) {
           this.vatAmount = formData.chosenCarrier.vatAmount
         }
       })
       .catch(e => {
         this.isReadySpot = false
         console.error(e);
         this.$notification({
           type: "system_notification_error",
           message: "Ошибка загрузки данных"
         });
       })

      this.getSpotsEvents()
  },
  computed: {
    routeBackUrl () {
      return this.isCompletedOrder ? '/spot-list-completed' : '/spot-list'
    },
    currentPriceValue () {
      return this.isAuctionProcessed ? this.winningBet : this.currentPrice
    },
    vatAmountValue () {
      return parseInt(this.vatAmount) ? `+ НДС ${formatNumber(this.vatAmount / 100)} ₽` : 'Эта ставка НДС не облагается'
    },
    bestBidText () {
      return this.isAuctionProcessed ? 'Ставка, победившая в аукционе' : 'Лучшая ставка'
    },
    isSummarizing () {
      return this.$route.params.status === 'AUCTION_ENDED' || this.isOrderAuctionEnded || this.isOrderProcessed
    },
    isOrderAuctionEnded () {
      return this.auctionStatus ? AUCTION_STATUS[this.auctionStatus] === AUCTION_STATUS.AUCTION_ENDED : ORDER_STATUS[this.orderStatus] === ORDER_STATUS.AUCTION_ENDED
    },
    isOrderProcessed () {
      return ORDER_STATUS[this.orderStatus] === ORDER_STATUS.PROCESSED
    },
    isCompletedOrder () {
      return ORDER_STATUS[this.orderStatus] === ORDER_STATUS.PROCESSED || ORDER_STATUS[this.orderStatus] === ORDER_STATUS.CANCELLED
    },
    isAuctionNew () {
      return this.auctionStatus === 'NEW'
    },
    isAuctionInProcess () {
      return this.auctionStatus === 'IN_PROCCESS'
    },
    isAuctionProcessed () {
      return this.auctionStatus === 'PROCESSED'
    },
    isAuctionCancelled () {
      return this.auctionStatus === 'CANCELLED'
    },
    classColor () {
      return {
        '-deep-blue': this.isAuctionProcessed,
        '-persian-red': this.isAuctionCancelled
      }
    },
    isHideWinnerBtn () {
      return !this.participant
    },
    hasSpotEvents() {
      return !!this.spotEvents.length
    },
    auctionColumns () {
      return [
        {
          title: 'дата',
          key: 'biddingDt',
          html: (item) => {
            return `
            <div>${this.transformTime(item.biddingDt)}<br />
              <span class="-grey">${this.transformDateShortVersion(
                item.biddingDt
              )}</span>
            </div>`
          },
          width: '50'
        },
        {
          title: 'ставка без ндс',
          key: 'bidAmount',
          html: (item) => {
            return `
              <div>${formatNumber(item.bidAmount / 100)}&nbsp;₽</div>
              <div class="-blue">${item.participantTitle}</div>`
          },
          width: '50'
        },
        {
          title: 'ндс',
          key: 'vatValue',
          html: (item) => {
            return `
              <div
                class="table__tax-price -grey">
                ${
                  item.isVatPayer
                    ? formatNumber(item.vatValue / 100) + '&nbsp;₽'
                    : 'Без НДС'
                }
              </div>`
          },
          width: '50'
        },
      ]
    },
    participantsItemsSearch () {
      if (this.search !== '') {
        return this.participantsItems.filter(item => {
          let str = item.title + ' ' + item.inn
          return str.toLowerCase().includes(this.search.toLowerCase())
        })
      }
      return this.participantsItems
    },
    participantCount () {
      return this.participantsUuid.length
    }
  },
  beforeDestroy () {
    clearTimeout(this.auctionTimer)
    clearTimeout(this.spotEventsTimer)
  },
  methods: {
    getParticipantList (formData = null) {
      api.spotAuction
         .getParticipantList(this.$route.params.uuid)
         .then(res => {
           this.participants = res.data.bidsDetails.length ? res.data.bidsDetails.sort((a, b) => {
             return a.bid - b.bid
           }) : []
           if (this.participants.length) {
             this.participant = this.participants[0].bidUuid
             this.winningBet = formatNumber(this.participants[0].bid / 100)
             this.winningVat = formatNumber(this.participants[0].vatValue / 100)
           }
         })
         .then(() => {
           if (formData && this.orderStatus === 'PROCESSED') {
             this.winningParticipant = formData.chosenCarrier.title
             this.winningVat = formatNumber(formData.chosenCarrier.vatAmount / 100)
             this.winningBet = formatNumber(formData.chosenCarrier.carrierPrice / 100)
           }
         })
    },
    getActualAuction (auctionUuid, orderUuid) {
      api.spotAuction.getActualAuction(auctionUuid, orderUuid)
         .then(response => {
           this.actualTime = response.data.actualTime
           this.auctionStatus = response.data.auctionStatus
           this.auctionStatusText = AUCTION_STATUS[response.data.auctionStatus]
           this.viewsCount = response.data.viewsCount
           this.bidsCount = response.data.bidsCount
           this.currentPrice = formatNumber(response.data.currentPrice / 100)
           this.bids = response.data.bids
           this.participantsItems = this.parseParticipants(response.data).participants

           if (this.isAuctionInProcess) {
             this.vatAmount = response.data.vatAmount
           }
           this.isReadyAuction = true
           return response.data.auctionStatus
         })
         .then(status => {
           if (status === 'IN_PROCCESS') {
             this.auctionTimer = setTimeout(this.getActualAuction.bind(null, auctionUuid, orderUuid), 5000)
           }
           if (status === 'AUCTION_ENDED') {
             this.getParticipantList()
           }
           this.spotEventsTimer = setTimeout(this.getSpotsEvents, 5000)
         })
         .catch(e => {
           this.isReadyAuction = false

           console.error(e);
           this.$notification({
             type: "system_notification_error",
             message: "Ошибка загрузки данных (аукцион)"
           });
         })
    },
    preprocContactPerson(item) {
      return `${item.name || ''},
      ${item.phone ? `<a href="tel:${item.phone}">${item.phone}</a>` : ''},
      ${item.email ? `<a href="mailto:${item.email}">${item.email}</a>` : ''}`
    },
    onSelectWinner (item) {
      this.participant = item
      const _participant = this.participants.find(participant => participant.bidUuid === item)
      this.winningBet = formatNumber(_participant.bid / 100)
      this.winningVat = formatNumber(_participant.vatValue / 100)
    },
    async setWinner () {
      try {
        await api.spotAuction.setWinningCarrier(this.$route.params.uuid, this.participant)
        .then(() => {
           const notificationId = new Date().getTime() + '_cancel'
           this.$notification({
             type: 'snackbars',
             id: notificationId,
             message: `${this.participants.filter(participant => participant.bidUuid === this.participant)[0].participantTitle} назначен победителем в споте ${this.spotNumber}. Спот переведен в раздел Завершенные`
           })
           setTimeout(async function () {
             await this.$router.push({ name: 'spot__list' })
           }.bind(this), 2000)
        })
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка отправки формы"
        });
      }
    },
    selectWinner (temp) {
      this.$refs.winner.setItem(temp);
    },
    transformTime (time) {
      return moment(time).format('HH:mm')
    },
    transformDate (time) {
      return moment(time).format('DD.MM.YYYY')
    },
    transformDateShortVersion (time) {
      return moment(time).format('DD.MM.YY')
    },
    onOpenModal () {
      this.$refs.cancelSpotModalItem.open()
    },
    onCancelSpot () {
      api.spotAuction
         .cancelSpotOrder(this.$route.params.uuid)
         .then(() => {
           this.getActualAuction(this.auctionUuid, this.$route.params.uuid)

           this.$refs.cancelSpotModalItem.close()

           const notificationId = new Date().getTime() + '_cancel'
           this.$notification({
             type: 'snackbars',
             id: notificationId,
             message: 'Спот отменен и переведен в раздел "Завершенные"'
           })
           setTimeout(() => {
             this.$notification({ event: 'close', id: notificationId })
           }, 5000)
         })
         .catch(e => {
           console.error(e);
           this.$notification({
             type: "system_notification_error",
             message: "Ошибка отмены"
           });
         })
    },
    parseParticipants (data) {
      return {
        ...data,
        participants: data.invitedGroupsOfParticipants ? data.invitedGroupsOfParticipants.reduce((filtered, group) => {
          return filtered.concat(group.participants.map(item => ({
            ...item,
            group: group || 'Без группы'
          })))
        }, []) : []
      }
    },
    onSearch (e) {
      this.search = e
    },
    onToggle (data, participantsUuid) {
      this.participantsUuid = participantsUuid
    },
    tableGroupTitleHtml (value) {
      return `
        <span>${value.title}</span>
        <span class="groups-header__count">${value.participants.length}</span>
      `
    },
    getSpotsEvents () {
      api.spotAuction.getSpotEvents(this.$route.params.uuid)
        .then((response) => {
          this.spotEvents = response.data.events
        })
        .catch(e => {
          console.error(e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных"
          })
        })
    }
  }
}
</script>

<style lang="scss" scoped>
@import "node_modules/common-components/src/static/css/variables";
@import "node_modules/common-components/src/static/css/mixins";

.ob-spot {
  .ob-content__header {
    .title {
      display: inline-block;
      font-size: 24px;
      line-height: 36px;
    }

    .icon {
      text-decoration: none;
      color: $color-blue-navy-blue;
      margin-right: 12px;
      font-size: 26px;
    }

    .ref {
      font-size: 10px;
      text-transform: uppercase;
      color: rgba($gray-slate, 0.8);
      align-self: flex-start;
      padding: 5px 0 0 5px;
    }
  }

  .ob-content__body h2 {
    font-size: 20px;
    font-weight: 700;
    line-height: 28px;
    margin-bottom: 20px;
  }

  /deep/ {
    .ob-spot-row {
      display: flex;
      justify-content: space-between;
      margin-bottom: 10px;
    }

    .ob-spot-col {
      flex: 1 1 auto;
      max-width: 50%;

      &:not(:last-child) {
        margin-right: 10px;
      }
    }
  }

  .ob-spot-canceled-block {
    pointer-events: none;
    z-index: 2000;
    position: absolute;
    top: 20%;
    left: 10%;
    text-align: center;
    color: $color-error;
    opacity: .2;
    transform: matrix(.86,-.48,.52,.87,0,0);
    transform-origin: right;
    font-size: 7vw;
    letter-spacing: 1.5vw;
    text-transform: uppercase;
  }
  .ob-spot-path {
    min-width: 760px;
    border: 1px solid $color-grey-border;
    border-radius: 3px;
    padding: 0 20px 20px;
    margin-bottom: 20px;
  }

  .ob-spot-description {
    background: $blue-150;
    padding: 20px;
    margin-bottom: 40px;
    border: 1px solid rgba($color-blue-navy-blue, 0.25);
    border-radius: 4px;
    box-sizing: border-box;
    overflow: hidden;

    &__type {
      margin-bottom: 20px;
      font-size: 16px;
      letter-spacing: 0.2px;

      .icon {
        font-size: 24px;
        margin-right: 16px;
        vertical-align: middle;
      }
    }

    .btn-winner {
      float: right;
      margin-top: 10px;
    }
  }

  .ob-spot-event {
    padding: 0 20px;

    &__item {
      font-size: 12px;
      padding: 6px 20px;
      background-color: $blue-150;
      margin-bottom: 2px;
      border-radius: 3px;
      display: flex;
      justify-content: space-between;

      p {
        align-items: center;
        text-transform: uppercase;
        color: $gray-slate;

        &:first-of-type,
        &:nth-of-type(2) {
          display: flex;
          flex: 1 1 auto;
        }

        &:first-of-type {
          width: 80px;
          flex-grow: 0;
          margin-right: 150px;
        }

        &:nth-of-type(2) {
          color: $style-black;
        }

        &:nth-of-type(2),
        &:last-of-type {
          margin: 10px 50px 10px 0;
        }
      }
    }
  }

  .ob-spot-auction {
    padding: 38px 21px 10px;
    text-align: center;

    &__status {
      position: relative;
      font-size: 12px;
      letter-spacing: 1.6px;
      text-transform: uppercase;
      color: $shale-gray;
      margin-bottom: 9px;

      /deep/ .ob-menu-dropdown-container {
        position: absolute;
        right: 0;
        top: 0;
      }
    }

    &__icons {
      margin-bottom: 25px;

      .icon {
        color: $color-blue-navy-blue;
        font-size: 16px;
        margin: 0 3px 0 10px;
      }

      > span {
        color: $Grey-900;
      }
    }

    &__rate {
      font-size: 10px;
      letter-spacing: 1.6px;
      text-transform: uppercase;
      margin: 0 30px 11px;
      color: $shale-gray;
    }

    &__price {
      position: relative;
      display: inline-block;
      font-size: 24px;
      font-weight: 700;
      letter-spacing: 0.2px;
      margin-bottom: 7px;

      .icon {
        position: absolute;
        left: calc(100% + 5px);
        top: calc(50% - 6px);
        font-size: 12px;
        color: $shale-gray;
      }
    }

    &__nds {
      font-size: 10px;
      letter-spacing: 0.4px;
      color: $gray-slate;
      margin-bottom: 37px;
    }

    &__note {
      font-size: 10px;
      color: $gray-slate;
    }
  }

  .ob-spot-rate {
    position: relative;
    height: auto;

    &__wrap {
      height: 100%;
      overflow-y: auto;
    }

    &__item {
      font-size: 14px;
      margin: 0 30px 20px;
      overflow: hidden;

      &-left {
        float: left;
        font-size: 12px;
        line-height: 20px;
        margin-right: 20px;

        .-gray {
          color: $color-grey-label;
        }
      }

      &-right {
        padding-left: 60px;
      }
    }

    &__price {
      margin-bottom: 5px;
    }

    &__company {
      color: $color-blue-navy-blue;
    }

    &__empty {
      color: $color-grey-span;
      font-size: 24px;
      line-height: 29px;
      margin: 41px 30px;
      text-align: center;
      font-weight: 400;
      letter-spacing: 0.4px;
    }
  }

  .ob-spot-bet {
    flex-grow: 0;
    width: 40%;
  }

  .winning-bet {
    border: 1px solid rgba($color-blue-navy-blue, 0.25);
    border-radius: 3px;
    min-height: 52px;

    &__label {
      position: relative;
      top: 8px;
      height: 16px;
      white-space: nowrap;
      text-overflow: ellipsis;
      overflow: hidden;
      padding: 0 11px;

      font-size: 12px;
      line-height: 12px;
      letter-spacing: 0.4px;
      font-weight: 400;
      color: $gray-slate;
    }

    &__price {
      height: 34px;
      line-height: 36px;
      font-size: 16px;
      letter-spacing: 0.2px;
      color: $Grey-900;
      padding-left: 11px;
    }
  }
}

.winner-list {
  &__items {
    padding: 20px 0;
  }

  &__item {
    display: flex;
    justify-content: space-between;
    align-content: center;
    height: 36px;
    font-size: 16px;
    color: $Grey-900;

    > div {
      padding-left: 7px;
      height: 36px;
      line-height: 36px;
      white-space: nowrap;
      text-overflow: ellipsis;
      overflow: hidden;

      span {
        color: $color-grey-span;
      }

      &:nth-of-type(1) {
        flex: 0 0 20px;
      }

      &:nth-of-type(2) {
        flex: 1 1 39%;
      }

      &:nth-of-type(3) {
        flex: 1 1 23%;
      }

      &:nth-of-type(4) {
        flex: 1 1 25%;

        span {
          font-size: 14px;
          padding-left: 20px;
        }
      }
    }

    &:hover {
      cursor: pointer;
      background-color: $light-lavender;
    }
  }
}

/deep/ {
  .preloader {
    margin: 20px;

    .loader {
      margin: 0 auto;
    }
  }

  .ob-spot-rate__wrap {
    table {
      min-width: 200px;

      .-grey {
        color: $color-grey-label;
      }

      .-blue {
         color: $color-blue-navy-blue;
      }

      .__tax-price {
        font-size: 10px;
        padding-bottom: 15px;
      }
    }

    .column-title {
      font-size: 11px;
      color: $color-grey-span;
    }

    .data-row {
      border-top: none;
      border-bottom: none;
      &:last-child {
        border-bottom: 1px solid $lavender;
      }
    }

    .td-container {
      padding: 8px 14px;
      font-size: 12px;
    }
  }

  .ob-tabs__panel {
    margin-left: 15px;
  }

  .ob-tabs-pane {
    &-wrap {
      padding: 25px 29px 25px;
    }

    &-title {
      font-weight: bold;
      font-size: 16px;
      color: $color-text-base;
      margin-bottom: 19px;
    }
  }

  .participants-table {
    .table-data {
      min-width: 100%;

      .participant {
        margin-left: 30px;
      }

      .groups-header {
        background-color: $white;
        &__count {
          right: 35px;
          position: absolute;
        }
      }
    }
  }
}
</style>
